Module Module1
    Public Array_Return(1) As Single
    Private Function Cosd(ByVal X As Single) As Single
        Cosd = Math.Cos(Math.PI / 180.0 * X)
    End Function
    Private Function Sind(ByVal X As Single) As Single
        Sind = Math.Sin(Math.PI / 180.0 * X)
    End Function
    Private Function Tand(ByVal X As Single) As Single
        Tand = Math.Tan(Math.PI / 180.0 * X)
    End Function
    Private Function Atand(ByVal X As Single) As Single
        Atand = Math.Atan(X) * 180.0 / Math.PI
    End Function
    Private Function Asind(ByVal X As Single) As Single
        Asind = Math.Asin(X) * 180.0 / Math.PI
    End Function
    Private Function Acosd(ByVal X As Single) As Single
        Acosd = Math.Acos(X) * 180.0 / Math.PI
    End Function
    Public Function loc2hor(ByVal z, ByVal d, ByVal p) As Single
        loc2hor = (Acosd((Cosd(z) - Sind(d) * Sind(p)) / Cosd(d) / Cosd(p)) / 15)
    End Function
    Public Function Round(ByVal x As Single, ByVal a As Single) As Single
        Dim tmp = x Mod a
        If (tmp < 0) Then tmp += a
        Round = tmp
    End Function
    Public Function Hms(ByVal x) As Date
        x = Math.Floor(3600 * x)
        Dim h = Math.Floor(x / 3600)
        Dim mp = x - 3600 * h
        Dim m = Math.Floor(mp / 60)
        Dim s = Math.Floor(mp - 60 * m)
        Hms = TimeSerial(Format$(h, "0#"), Format$(m, "0#"), Format$(s, "0#"))
    End Function
    Public Sub Sun(ByVal M As Byte, ByVal Dy As Byte, ByVal H As Byte, ByVal LG As Single)
        Dim D As Double
        Const e = 0.0167065
        Dim i As Integer
        If M < 7 Then
            D = 31 * (M - 1) + Dy + H / 24
        Else
            D = 6 + 30 * (M - 1) + Dy + H / 24
        End If
        Dim Mh = 74.2023 + 0.98560026 * D
        Dim L = -2.75043 + 0.98564735 * D
        Dim lst = 8.3162159 + 0.065709824 * Math.Floor(D) + 1.00273791 * 24 * (D Mod 1) + LG / 15
        Dim omega = 4.85131 - 0.052954 * D
        Dim ep = 23.4384717 + 0.00256 * Cosd(omega)
        Dim ed = 180.0 / Math.PI * e
        Dim u = M
        For i = 1 To 4
            u -= (u - ed * Sind(u) - M) / (1 - e * Cosd(u))
        Next
        Dim v = 2 * Atand(Tand(u / 2) * Math.Sqrt((1 + e) / (1 - e)))
        Dim theta = L + v - M - 0.00569 - 0.00479 * Sind(omega)
        Dim delta = Asind(Sind(ep) * Sind(theta))
        Dim alpha = 180.0 / Math.PI * Math.Atan2(Cosd(ep) * Sind(theta), Cosd(theta))
        If (alpha >= 360) Then alpha -= 360
        Dim ha = lst - alpha / 15
        Dim zr = Round(H - ha, 24)
        Array_Return(0) = zr
        Array_Return(1) = delta
    End Sub
End Module
